#!/bin/sh
#
# geninitrd mod: udev
USE_UDEV=${USE_UDEV:-yes}

#
# TODO:
# - make udev start before insmods
# - make proper use of USE_UDEV - don't copy rules if USE_UDEV is off no!

# setup geninitrd module
# @access	public
setup_mod_udev() {
	udevd=$(find_tool $initrd_dir/udevd /sbin/initrd-udevd)
	udevadm=$(find_tool $initrd_dir/udevadm /sbin/initrd-udevadm)

	if [ "$kernel_version" -lt "002006" ] || [ ! -x "$udevd" -o ! -x "$udevadm" -o ! -f /etc/udev/udev.conf ]; then
		USE_UDEV=no
	fi

	if is_yes "$USE_UDEV"; then
		. /etc/udev/udev.conf
	fi
}

# generate initrd fragment
# @access	public
initrd_gen_udev() {
	debug "Setting up udev..."

	inst_d /sbin /etc/udev
	inst_exec $udevd /sbin/udevd
	inst_exec $udevadm /sbin/udevadm
	inst /etc/udev/udev.conf /etc/udev/udev.conf

	mount_dev
	mount_sys
	add_linuxrc <<-'EOF'
		: 'Starting udev'
		/sbin/udevd --daemon
		/sbin/udevadm trigger
		/sbin/udevadm settle
	EOF
}

initrd_gen_stop_udevd() {
	busybox_applet killall
	add_linuxrc	<<-'EOF'
		killall udevd
	EOF
}
